Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Syndication
Imports System.ServiceModel.Web
Imports System.Text

Namespace SyndicationServiceLibrary1
	' NOTE: If you change the class name "Feed1" here, you must also update the reference to "Feed1" in App.config.
	Public Class Feed1
		Implements IFeed1
		Public Function CreateFeed() As SyndicationFeedFormatter Implements IFeed1.CreateFeed
			' Create a new Syndication Feed.
			Dim feed As New SyndicationFeed("Feed Title", "A WCF Syndication Feed", Nothing)
			Dim items As List(Of SyndicationItem) = New List(Of SyndicationItem)()

			' Create a new Syndication Item.
			Dim item As New SyndicationItem("An item", "Item content", Nothing)
			items.Add(item)
			feed.Items = items

			' Return ATOM or RSS based on query string
			' rss -> http://localhost:8731/Design_Time_Addresses/SyndicationServiceLibrary1/Feed1/
			' atom -> http://localhost:8731/Design_Time_Addresses/SyndicationServiceLibrary1/Feed1/?format=atom
			Dim query As String = WebOperationContext.Current.IncomingRequest.UriTemplateMatch.QueryParameters("format")
			Dim formatter As SyndicationFeedFormatter = Nothing
			If query = "atom" Then
				formatter = New Atom10FeedFormatter(feed)
			Else
				formatter = New Rss20FeedFormatter(feed)
			End If

			Return formatter
		End Function
	End Class
End Namespace
